// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2009-2011 - DIGITEO - Michael Baudin

//
// This file must be used under the terms of the GNU LGPL license.
// 

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// Check the Niederreiter base 2 sequence
//
lds = ldnied2_new();
lds = ldnied2_configure(lds,"-dimension",2);
lds = ldnied2_startup (lds);
// Term #1
[lds,computed] = ldnied2_next (lds);
expected = [1./2. 1./2.];
assert_checkalmostequal ( computed, expected , 10 * %eps );
// Terms #2 to #5
[lds,computed]=ldnied2_next(lds,4);
expected= [
    3./4. 1./4. 
    1./4. 3./4. 
    3./8. 3./8. 
    7./8. 7./8. 
];
assert_checkalmostequal ( computed, expected , 10 * %eps );
lds = ldnied2_destroy(lds);


